/*****************************************************
CVAVR V2.05
Chip type               : ATmega8
AVR Core Clock frequency: 8 MHz
*****************************************************/
#include <mega8.h>

#define ADC_itn 8

#define s_step 156
flash unsigned char s_table [s_step/2]=
{0,5,10,15,20,25,31,36,41,46,51,56,61,66,71,76,81,86,91,96,100,
105,110,115,119,124,128,133,137,141,146,150,154,158,162,166,170,174,178,181,185,189,
192,195,199,202,205,208,211,214,217,219,222,225,227,229,232,234,236,238,240,241,243,
245,246,247,249,250,251,252,253,253,254,254,255,255,255,255};

bit LoBat=0;
unsigned char c=0;
unsigned char tmr0, tmr1, ADC1;

void t0_cfg()
{
 TCCR1A=0;
 TCCR1A=0; TCCR1A|=1<<COM1A1|1<<COM1B1|1<<WGM10;
 TCCR1B=0;TCCR1B|=1<<CS00;
 TIMSK|=1<<TOIE1;
}
void ports_cfg()
{
 PORTB=0; DDRB =0b11110110;
}
void adc_cfg()
{
 ADMUX|=1<<REFS0|1<<ADLAR|1;
 ADCSRA|=1<<ADEN|1<<ADSC|7;
}
void adc_scan()
{
 static unsigned char ADC1_tmp [ADC_itn]; 
 unsigned int dtmp=0;
 unsigned char i = 0;
 static bit a1f=0;
 
 if (!a1f) {for(i=0;i<ADC_itn-1;i++){ADC1_tmp[i]=200;a1f=1;}}

if(!ADCSRA.ADSC)
{ 
  for (i=0; i<(ADC_itn-1); i++ ) {ADC1_tmp [i] = ADC1_tmp [i+1];}
  ADC1_tmp [(ADC_itn-1)] = ADCH;
  for (i=0; i<(ADC_itn); i++ ) { dtmp += ADC1_tmp [i];}
  ADC1 = dtmp/ADC_itn; 
  ADCSRA |= 1<<ADSC;
}
}
void bat_detect()
{
 if(ADC1>170){tmr1=250;}   
 else if (ADC1<50){LoBat=1;tmr0=250;}
 if(!tmr1) {LoBat=1;tmr0=250;} 
 if(!tmr0) {LoBat=0;}
}

interrupt [TIM1_OVF] void t1_ovf_isr()
{
 #define dtv 4
 static bit dir;
 
 if(!c)                                          
 {
 dir=1;c=1;
 DDRB^=0b00111001;
 if(tmr0)tmr0--;    
 if(tmr1)tmr1--;
 }
 else if((dir)&&(c<s_step/2))
 {OCR1BL=s_table[c];if(s_table[c]>dtv){OCR1AL=s_table[c]-dtv;}else{OCR1AL=0;} c++;}
 else {c--; OCR1BL=s_table[c];if(s_table[c]>dtv){OCR1AL=s_table[c]-dtv;}else{OCR1AL=0;} dir=0;} 
 
 #asm("wdr")  
}

void main(void)
{
ports_cfg();
t0_cfg();
//adc_cfg();

#asm("sei")

while (1)
      {  


       
      }
}
